<?php

declare(strict_types = 1);

namespace rark\simple_fill\listener;

use pocketmine\event\Listener;
use pocketmine\event\player\{
	PlayerQuitEvent,
	PlayerInteractEvent,
	PlayerDropItemEvent,
	PlayerItemConsumeEvent
};
use rark\simple_fill\Main;
use rark\simple_fill\utils\Fill;
use function rark\simple_fill\utils\sound;


final class PlayerEventListener implements Listener{

	public function onQuit(PlayerQuitEvent $event):void{
		Main::$fill->unregisterPlayer($event->getPlayer());
	}

	public function onInteract(PlayerInteractEvent $event):void{
		$player = $event->getPlayer();
		$item = $event->getItem();

		if($item->getCustomName() !== Main::$item->getCustomName()){
			return;

		}else{
			if(!$player->isOp()){
				return;
			}

			if(Main::$fill->isRegisteredPlayer($player)){
				sound($player);
				Main::$fill->unregisterPlayer($player);
				$player->sendMessage(Main::HEADER.'§bFillモードをOFFにしました');
			
			}else{
				sound($player);
				Main::$fill->registerPlayer($player);
				$player->sendMessage(Main::HEADER.'§aFillモードをONにしました');
			}
		}
	}

	public function onDrop(PlayerDropItemEvent $event):void{
		$item = $event->getItem();

		if($item->getCustomName() === Main::$item->getCustomName()){
			$event->getPlayer()->getInventory()->removeItem($item);
			$event->setCancelled();
		}
	}
}